#
# spec file for package hypre
#
# Copyright (c) 2012 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define somver 0
%define sover %{somver}.2.6

Name:           hypre
Version:        2.8.0b
Release:        1.3
Summary:        Scalable algorithms for solving linear systems of equations
License:        LGPL-2.1
Group:          Development/Libraries/Parallel
Url:            http://www.llnl.gov/casc/hypre/
Source:         %{name}-%{version}.tar.xz
Source1:        babel_files
Patch0:         hypre-2.8.0b-no-date-and-time-fix.patch
%if 0%{?suse_version} <= 1110
%{!?python_sitearch: %global python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif
# TODO : add babel
#BuildRequires:  babel-devel
BuildRequires:  gcc-c++
BuildRequires:  gcc-fortran
BuildRequires:  java-devel
BuildRequires:  lapack-devel
BuildRequires:  openmpi-devel
#BuildRequires:  libltdl-devel
#BuildRequires:  superlu-devel
BuildRequires:  libxml2-devel
%if 0%{?sles_version}
BuildRequires:  mvapich2-devel
%endif
BuildRequires:  python-devel
BuildRequires:  python-numpy-devel
BuildRequires:  python-xml
BuildRequires:  xz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%if 0%{?sles_version}
%define _mpi openmpi mvapich2
%else
%define _mpi openmpi
%endif

%description
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.


%package -n libHYPRE%{somver}
Summary:        Shared libraries of Hypre
Group:          System/Libraries

%description -n libHYPRE%{somver}
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains serial shared libraries of Hypre.


%package devel
Summary:        Development files of Hypre
Group:          Development/Libraries/C and C++
Requires:       libHYPRE%{somver} = %{version}
#Requires:       libbabel-devel
#Requires:       libltdl-devel
#Requires:       superlu-devel

%description devel
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains development files of the serial version of Hypre.


%package -n libHYPRE%{somver}-openmpi
Summary:        Shared libraries of Hypre
Group:          System/Libraries

%description -n libHYPRE%{somver}-openmpi
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains parallel shared libraries of Hypre for openmpi.

%package openmpi-devel
Summary:        Development files of Hypre
Group:          Development/Libraries/Parallel
Requires:       libHYPRE%{somver}-openmpi = %{version}
Requires:       openmpi-devel
#Requires:       libbabel-devel
#Requires:       libltdl-devel
#Requires:       superlu-devel

%description openmpi-devel
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains development files of Hypre.

%if 0%{?sles_version}
%package -n libHYPRE%{somver}-mvapich2
Summary:        Shared libraries of Hypre
Group:          System/Libraries

%description -n libHYPRE%{somver}-mvapich2
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains parallel shared libraries of Hypre for mvapich2.

%package mvapich2-devel
Summary:        Development files of Hypre
Group:          Development/Libraries/Parallel
Requires:       libHYPRE%{somver}-mvapich2 = %{version}
Requires:       mvapich2-devel
#Requires:       libbabel-devel
#Requires:       libltdl-devel
#Requires:       superlu-devel

%description mvapich2-devel
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains development files of Hypre.
%endif

%package doc
Summary:        Development documentation for Hypre
Group:          Documentation/Other

%description doc
The goal of the Scalable Linear Solvers project is to develop scalable
algorithms and software for solving large, sparse linear systems of equations on
parallel computers. The primary software product is Hypre, a library of high
performance preconditioners that features parallel multigrid methods for both
structured and unstructured grid problems. The problems of interest arise in the
simulation codes being developed at LLNL and elsewhere to study physical
phenomena in the defense, environmental, energy, and biological sciences.

This package contains development documentation for Hypre.

%prep
%setup -q
%patch0 -p1

set -- *
mkdir serial
cp -ap "$@" serial

for mpi in %_mpi; do
 mkdir $mpi
 cp -ap "$@" $mpi
done


%build
export includedir=%{_includedir}
export JNI_INCLUDES="%{_libexecdir}/jvm/java/include"

# build serial vesrion
cd serial/src
FLAGS="%optflags -fPIC -I%{_includedir}/numpy"
%configure \
 	--without-examples \
	--without-MPI \
	--with-timing \
	--without-openmp \
	--with-blas-libs=-lblas \
	--with-blas-lib-dirs=%{_libdir} \
        --with-lapack-libs="-llapack" \
        --with-lapack-lib-dirs=%{_libdir} \
	--with-lapack \
	--with-mli \
	--with-fei \
        --with-superlu \
	CC="gcc $FLAGS" \
	CXX="g++ $FLAGS" \
	F77="gfortran $FLAGS"
mkdir -p hypre/lib
pushd FEI_mv/femli
make %{?_smp_mflags} all
popd
make %{?_smp_mflags} all
cd ../..


# build parallel verions
for mpi in %_mpi; do
cd $mpi
export MPIDIR=%{_libdir}/mpi/gcc/$mpi
cd src

FLAGS="%optflags -fPIC -I%{_includedir}/numpy"
%configure \
        --prefix=%{_libdir}/mpi/gcc/$mpi \
	--without-examples \
	--with-MPI \
	--with-MPI-include=%{_libdir}/mpi/gcc/$mpi/include \
	--with-MPI-lib-dirs="%{_libdir}/mpi/gcc/$mpi/%_lib" \
	--with-timing \
	--without-openmp \
	--with-blas-libs=-lblas \
	--with-blas-lib-dirs=%{_libdir} \
        --with-lapack-libs="-llapack" \
        --with-lapack-lib-dirs=%{_libdir} \
	--with-lapack \
	--with-mli \
	--with-fei \
        --with-superlu \
	CC="mpicc $FLAGS" \
	CXX="mpicxx $FLAGS" \
	F77="mpif77 $FLAGS" \
	MPI_PREFIX=%{_libdir}/mpi/gcc/$mpi
mkdir -p hypre/lib
pushd FEI_mv/femli
make %{?_smp_mflags} all CC="%{_libdir}/mpi/gcc/$mpi/bin/mpicc $FLAGS" \
                         CXX="%{_libdir}/mpi/gcc/$mpi/bin/mpicxx $FLAGS" \
                         F77="%{_libdir}/mpi/gcc/$mpi/bin/mpif77 $FLAGS"
popd
make %{?_smp_mflags} all CC="%{_libdir}/mpi/gcc/$mpi/bin/mpicc $FLAGS" \
                         CXX="%{_libdir}/mpi/gcc/$mpi/bin/mpicxx $FLAGS" \
                         F77="%{_libdir}/mpi/gcc/$mpi/bin/mpif77 $FLAGS"
cd ../..
done

%install
cd serial
pushd src

# %%makeinstall macro does not work with hypre
make install HYPRE_INSTALL_DIR=%{buildroot}%{_prefix} \
             HYPRE_LIB_INSTALL=%{buildroot}%{_libdir} \
             HYPRE_INC_INSTALL=%{buildroot}%{_includedir}/%{name}
install -m644 hypre/lib/* %{buildroot}%{_libdir}

# Fix wrong permissions
chmod 644 %{buildroot}%{_includedir}/%{name}/LLNL_FEI_*.h

install -d %{buildroot}%{_docdir}/%{name}
rm -f ../src/docs/Makefile
cp -fR ../src/docs/* %{buildroot}%{_docdir}/%{name}/
# This files are provided with babel
rm -f %{buildroot}%{_libdir}/libsidl*
popd

# shared libraries

pushd %{buildroot}%{_libdir}
LIBS="$(ls *.a|sed 's|\.a||'|sort)"
mkdir tmp
pushd tmp
for i in $LIBS; do
	if [ "$i" != "libbHYPREClient-F" -a "$i" != "libbHYPREClient-CX" ]
	then
		ar x ../$i.a
		g++ -shared * -L.. $ADDLIB \
			      -llapack -lblas \
			      -Wl,-soname,$i.so.%{somver} -o ../$i.so.%sover
		ln -s $i.so.%sover ../$i.so.%{somver}
		ln -s $i.so.%{somver} ../$i.so
		rm -f *
		ADDLIB="-lHYPRE"
	fi
done
popd
rmdir tmp
popd
cd ..


# install parallel version
for mpi in %_mpi; do
cd $mpi
pushd src

# %%makeinstall macro does not work with hypre
make install HYPRE_INSTALL_DIR=%{buildroot}%{_libdir}/mpi/gcc/$mpi \
             HYPRE_LIB_INSTALL=%{buildroot}%{_libdir}/mpi/gcc/$mpi/%_lib \
             HYPRE_INC_INSTALL=%{buildroot}%{_libdir}/mpi/gcc/$mpi/include/%{name}
install -m644 hypre/lib/* %{buildroot}%{_libdir}/mpi/gcc/$mpi/%_lib

# Fix wrong permissions
chmod 644 %{buildroot}%{_libdir}/mpi/gcc/$mpi/include/%{name}/LLNL_FEI_*.h

# This files are provided with babel
rm -f %{buildroot}%{_libdir}/mpi/gcc/$mpi/%_lib/libsidl*
popd

# shared libraries

pushd %{buildroot}%{_libdir}/mpi/gcc/$mpi/%_lib
LIBS="$(ls *.a|sed 's|\.a||'|sort)"
mkdir tmp
pushd tmp
for i in $LIBS; do
	if [ "$i" != "libbHYPREClient-F" -a "$i" != "libbHYPREClient-CX" ]
	then
		ar x ../$i.a
		%{_libdir}/mpi/gcc/$mpi/bin/mpicxx -shared * -L.. $ADDLIB \
			           -llapack -lblas \
			           -Wl,-soname,$i.so.%{somver} -o ../$i.so.%sover
		ln -s $i.so.%sover ../$i.so.%{somver}
		ln -s $i.so.%{somver} ../$i.so
		rm -f *
		ADDLIB="-lHYPRE"
	fi
done
popd
rmdir tmp
popd
cd ..
done

%post -n libHYPRE%{somver} -p /sbin/ldconfig
%postun -n libHYPRE%{somver} -p /sbin/ldconfig

%post -n libHYPRE%{somver}-openmpi -p /sbin/ldconfig
%postun -n libHYPRE%{somver}-openmpi -p /sbin/ldconfig

%if 0%{?sles_version}
%post -n libHYPRE%{somver}-mvapich2 -p /sbin/ldconfig
%postun -n libHYPRE%{somver}-mvapich2 -p /sbin/ldconfig
%endif

%files -n libHYPRE%{somver}
%defattr(-,root,root,-)
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%doc CHANGELOG COPYING.LESSER COPYRIGHT
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/%{name}
%exclude %{_includedir}/%{name}/Cnames.h
%exclude %{_includedir}/%{name}/supermatrix.h
%exclude %{_includedir}/%{name}/slu_*.h


%files -n libHYPRE%{somver}-openmpi
%defattr(-,root,root,-)
%{_libdir}/mpi/gcc/openmpi/%_lib/*.so.*

%files openmpi-devel
%defattr(-,root,root,-)
%doc CHANGELOG COPYING.LESSER COPYRIGHT
%{_libdir}/mpi/gcc/openmpi/%_lib/*.so
%{_libdir}/mpi/gcc/openmpi/%_lib/*.a
%{_libdir}/mpi/gcc/openmpi/include/%{name}
%exclude %{_libdir}/mpi/gcc/openmpi/include/%{name}/Cnames.h
%exclude %{_libdir}/mpi/gcc/openmpi/include/%{name}/supermatrix.h
%exclude %{_libdir}/mpi/gcc/openmpi/include/%{name}/slu_*.h

%if 0%{?sles_version}
%files -n libHYPRE%{somver}-mvapich2
%defattr(-,root,root,-)
%{_libdir}/mpi/gcc/mvapich2/%_lib/*.so.*

%files mvapich2-devel
%defattr(-,root,root,-)
%doc CHANGELOG COPYING.LESSER COPYRIGHT
%{_libdir}/mpi/gcc/mvapich2/%_lib/*.so
%{_libdir}/mpi/gcc/mvapich2/%_lib/*.a
%{_libdir}/mpi/gcc/mvapich2/include/%{name}
%exclude %{_libdir}/mpi/gcc/mvapich2/include/%{name}/Cnames.h
%exclude %{_libdir}/mpi/gcc/mvapich2/include/%{name}/supermatrix.h
%exclude %{_libdir}/mpi/gcc/mvapich2/include/%{name}/slu_*.h
%endif

%files doc
%defattr(-,root,root,-)
%{_docdir}/%{name}

%changelog
* Thu Aug  2 2012 scorot@free.fr
- add baselibs.conf
- build serial version
- fix shared libs package name
* Thu Aug  2 2012 scorot@free.fr
- patch0
- move %%%%doc files to devel package
* Mon Jul 30 2012 scorot@free.fr
- add mvapich2 build for SLE 11
* Sun Jul 29 2012 scorot@free.fr
- fist package based on alt linux spec file
